public inbox for git-commits@fedoraproject.org
help / color / mirror / Atom feed
* [tests/selinux] pr775-checkpolicy-revdeps: test if spamd can search the /var/lib/snapd directory
@ 2026-09-11 13:21 Milos Malik
  0 siblings, 0 replies; only message in thread
From: Milos Malik @ 2026-09-11 13:21 UTC (permalink / raw)
  To: git-commits

            A new commit has been pushed.

            Repo   : tests/selinux
            Branch : pr775-checkpolicy-revdeps
            Commit : 8ddb24101cdc6e08eb4b945927c72152e968d610
            Author : Milos Malik <mmalik@redhat.com>
            Date   : 2023-11-01T11:36:35+00:00
            Stats  : +204/-0 in 4 file(s)
            URL    : https://src.fedoraproject.org/tests/selinux/c/8ddb24101cdc6e08eb4b945927c72152e968d610?branch=pr775-checkpolicy-revdeps

            Log:
            test if spamd can search the /var/lib/snapd directory

A recently filed BZ report revealed that SELinux prevents the spamd
processes from searching (syscall = newfstatat) the /var/lib/snapd
directory when the snapd package is installed. The TC reproduces
the situation.

Because the spamassassin service logs indicate that the spamd functions
are not affected by the denied access, I believe that SELinux policy
should dontaudit the action. The TC looks for appropriate policy rules
and file context patterns.

The TC covers BZ#2207725.

---
diff --git a/selinux-policy/snapd-and-similar/Makefile b/selinux-policy/snapd-and-similar/Makefile
new file mode 100644
index 0000000..e44655c
--- /dev/null
+++ b/selinux-policy/snapd-and-similar/Makefile
@@ -0,0 +1,68 @@
+# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+#
+#   Makefile of /CoreOS/selinux-policy/Regression/snapd-and-similar
+#   Description: SELinux interferes with the snapd service and related programs
+#   Author: Milos Malik <mmalik@redhat.com>
+#
+# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+#
+#   Copyright (c) 2023 Red Hat, Inc. All rights reserved.
+#
+#   This copyrighted material is made available to anyone wishing
+#   to use, modify, copy, or redistribute it subject to the terms
+#   and conditions of the GNU General Public License version 2.
+#
+#   This program is distributed in the hope that it will be
+#   useful, but WITHOUT ANY WARRANTY; without even the implied
+#   warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+#   PURPOSE. See the GNU General Public License for more details.
+#
+#   You should have received a copy of the GNU General Public
+#   License along with this program; if not, write to the Free
+#   Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+#   Boston, MA 02110-1301, USA.
+#
+# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+export TEST=/CoreOS/selinux-policy/Regression/snapd-and-similar
+export TESTVERSION=1.0
+
+BUILT_FILES=
+
+FILES=$(METADATA) runtest.sh Makefile PURPOSE
+
+.PHONY: all install download clean
+
+run: $(FILES) build
+	./runtest.sh
+
+build: $(BUILT_FILES)
+	chmod a+x runtest.sh
+	chcon -t bin_t runtest.sh
+
+clean:
+	rm -f *~ $(BUILT_FILES)
+
+include /usr/share/rhts/lib/rhts-make.include
+
+$(METADATA): Makefile
+	@echo "Owner:           Milos Malik <mmalik@redhat.com>" > $(METADATA)
+	@echo "Name:            $(TEST)" >> $(METADATA)
+	@echo "TestVersion:     $(TESTVERSION)" >> $(METADATA)
+	@echo "Path:            $(TEST_DIR)" >> $(METADATA)
+	@echo "Description:     SELinux interferes with the snapd service and related programs" >> $(METADATA)
+	@echo "Type:            Regression" >> $(METADATA)
+	@echo "TestTime:        10m" >> $(METADATA)
+	@echo "RunFor:          selinux-policy" >> $(METADATA)
+	@echo "Requires:        audit libselinux libselinux-utils policycoreutils selinux-policy selinux-policy-targeted setools-console snapd snapd-selinux /usr/sbin/service spamassassin" >> $(METADATA)
+	@echo "RhtsRequires:    library(selinux-policy/common)" >> $(METADATA)
+	@echo "Environment:     AVC_ERROR=+no_avc_check" >> $(METADATA)
+	@echo "Priority:        Normal" >> $(METADATA)
+	@echo "License:         GPLv2" >> $(METADATA)
+	@echo "Confidential:    no" >> $(METADATA)
+	@echo "Destructive:     no" >> $(METADATA)
+	@echo "Releases:        -RHEL4 -RHEL5 -RHEL6 -RHEL7" >> $(METADATA)
+	@echo "Bug:             2207725" >> $(METADATA) # Fedora 38
+
+	rhts-lint $(METADATA)
+

diff --git a/selinux-policy/snapd-and-similar/PURPOSE b/selinux-policy/snapd-and-similar/PURPOSE
new file mode 100644
index 0000000..6788078
--- /dev/null
+++ b/selinux-policy/snapd-and-similar/PURPOSE
@@ -0,0 +1,5 @@
+PURPOSE of /CoreOS/selinux-policy/Regression/snapd-and-similar
+Author: Milos Malik <mmalik@redhat.com>
+
+SELinux interferes with the snapd service and related programs
+

diff --git a/selinux-policy/snapd-and-similar/main.fmf b/selinux-policy/snapd-and-similar/main.fmf
new file mode 100644
index 0000000..34efcfa
--- /dev/null
+++ b/selinux-policy/snapd-and-similar/main.fmf
@@ -0,0 +1,41 @@
+summary: SELinux interferes with the snapd service and related programs
+description: |+
+    SELinux interferes with the snapd service and related programs.
+
+contact: Milos Malik <mmalik@redhat.com>
+component:
+  - selinux-policy
+require:
+  - library(selinux-policy/common)
+recommend:
+  - audit
+  - libselinux
+  - libselinux-utils
+  - policycoreutils
+  - selinux-policy
+  - selinux-policy-targeted
+  - setools-console
+  - snapd
+  - snapd-selinux
+  - /usr/sbin/service
+  - spamassassin
+environment:
+    AVC_ERROR: +no_avc_check
+duration: 10m
+enabled: true
+tag:
+  - NoRHEL4
+  - NoRHEL5
+  - NoRHEL6
+  - failinfedora
+  - targeted
+link:
+  - verifies: https://bugzilla.redhat.com/show_bug.cgi?id=2207725
+adjust:
+  - enabled: false
+    when: distro == rhel-4, rhel-5, rhel-6
+    because: the snapd package is not available there
+extra-summary: /CoreOS/selinux-policy/Regression/snapd-and-similar
+extra-task: /CoreOS/selinux-policy/Regression/snapd-and-similar
+extra-nitrate: TC#0615881
+id: 7483a2b6-5a30-4538-b728-85e75d0542ef

diff --git a/selinux-policy/snapd-and-similar/runtest.sh b/selinux-policy/snapd-and-similar/runtest.sh
new file mode 100755
index 0000000..a644221
--- /dev/null
+++ b/selinux-policy/snapd-and-similar/runtest.sh
@@ -0,0 +1,90 @@
+#!/bin/bash
+# vim: dict=/usr/share/beakerlib/dictionary.vim cpt=.,w,b,u,t,i,k
+# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+#
+#   runtest.sh of /CoreOS/selinux-policy/Regression/snapd-and-similar
+#   Description: SELinux interferes with the snapd service and related programs
+#   Author: Milos Malik <mmalik@redhat.com>
+#
+# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+#
+#   Copyright (c) 2023 Red Hat, Inc. All rights reserved.
+#
+#   This copyrighted material is made available to anyone wishing
+#   to use, modify, copy, or redistribute it subject to the terms
+#   and conditions of the GNU General Public License version 2.
+#
+#   This program is distributed in the hope that it will be
+#   useful, but WITHOUT ANY WARRANTY; without even the implied
+#   warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+#   PURPOSE. See the GNU General Public License for more details.
+#
+#   You should have received a copy of the GNU General Public
+#   License along with this program; if not, write to the Free
+#   Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+#   Boston, MA 02110-1301, USA.
+#
+# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+# Include Beaker environment
+. /usr/share/beakerlib/beakerlib.sh || exit 1
+
+PACKAGE="selinux-policy"
+FILE_PATH="/usr/libexec/snapd/snapd"
+FILE_CONTEXT="snappy_exec_t"
+SERVICE_PACKAGE="snapd"
+SERVICE_NAME="snapd"
+PROCESS_NAME="snapd"
+PROCESS_CONTEXT="snappy_t"
+
+rlJournalStart
+    rlPhaseStartSetup
+        rlRun "rlImport 'selinux-policy/common'"
+        rlSESatisfyRequires
+        rlAssertRpm ${PACKAGE}
+        rlAssertRpm ${PACKAGE}-targeted
+        rlAssertRpm ${SERVICE_PACKAGE}
+        rlAssertRpm spamassassin
+
+        # rlServiceStop ${SERVICE_NAME}
+
+        rlSESetEnforce
+        rlSEStatus
+        rlSESetTimestamp
+        sleep 2
+    rlPhaseEnd
+
+    rlPhaseStartTest "bz#2207725"
+        rlSEMatchPathCon "${FILE_PATH}" "${FILE_CONTEXT}"
+        rlSEMatchPathCon "/var/lib/snapd" "snappy_var_lib_t"
+        rlSESearchRule "allow init_t ${FILE_CONTEXT} : file { getattr open read execute } [ ]"
+        rlSESearchRule "allow init_t ${PROCESS_CONTEXT} : process { transition } [ ]"
+        rlSESearchRule "type_transition init_t ${FILE_CONTEXT} : process ${PROCESS_CONTEXT}"
+        rlSESearchRule "allow spamd_t snappy_var_lib_t : dir { search } [ ]"
+    rlPhaseEnd
+
+    rlPhaseStartTest "real scenario -- standalone service"
+        rlRun "ls -alRZ /var/lib/snapd"
+        rlRun "semodule -lfull | grep snap"
+        rlRun "service spamassassin start"
+        rlRun "service spamassassin status"
+        if ! rlSEDefined ${PROCESS_CONTEXT} ; then
+            # for environments where the SELinux domain does not exist yet
+            PROCESS_CONTEXT="unconfined_service_t"
+        fi
+        rlSEService - ${SERVICE_NAME} ${PROCESS_NAME} ${PROCESS_CONTEXT} "start status" 1
+        rlRun "restorecon -Rv /var /run -e /var/ARTIFACTS" 0-255
+        rlSEService - ${SERVICE_NAME} ${PROCESS_NAME} ${PROCESS_CONTEXT} "restart status stop status" 1
+        rlRun "service spamassassin stop"
+        rlRun "service spamassassin status" 3
+    rlPhaseEnd
+
+    rlPhaseStartCleanup
+        sleep 2
+        rlSECheckAVC
+
+        # rlServiceRestore ${SERVICE_NAME}
+    rlPhaseEnd
+rlJournalPrintText
+rlJournalEnd
+

^ permalink raw reply related	[flat|nested] only message in thread

only message in thread, other threads:[~2026-09-11 13:21 UTC | newest]

Thread overview: (only message) (download: mbox.gz / follow: Atom feed)
-- links below jump to the message on this page --
2026-09-11 13:21 [tests/selinux] pr775-checkpolicy-revdeps: test if spamd can search the /var/lib/snapd directory Milos Malik

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox